const currentUrl = window.location.href;

// close popups with escape key
document.addEventListener("keydown", (event) => {
  if (event.isComposing || event.key === 'Escape') {
    Array.from(document.getElementsByClassName("popup")).forEach(function(x) {
        x.style.display = 'none';
    });
    document.getElementById("registerPopupText").innerText = "";
  }
});

// register popup
document.getElementById("register").addEventListener("click", function () {
    registerPopup.style.display = 'flex';
});
// cancel
document.getElementById("registercancel").addEventListener("click", function () {
    registerPopup.style.display = 'none';
    document.getElementById("registerPopupText").innerText = "";
});
// confirm
document.getElementById("registerconfirm").addEventListener("click", async function () {
    const apiUrl = `${currentUrl}account/register`;
    const inputFieldSharedSecret = document.getElementById("sharedsecret");
    const inputFieldPublicKey = document.getElementById("publickey");
    let pubkey = null;
    if (!inputFieldPublicKey.value) {
        const { privateKey, publicKey } = await genKey();
        pubkey = exportedKeyToPem(publicKey, "public");
        document.getElementById("registerPopupText").innerText = exportedKeyToPem(privateKey, "private");
    } else {
        pubkey = inputFieldPublicKey.value;
    }
    const postData = {
        sharedSecret: inputFieldSharedSecret.value,
        publicKey: pubkey
    };
    // clear input fields
    inputFieldSharedSecret.value='';
    inputFieldPublicKey.value='';

    const requestOptions = {
        method: 'POST',
        headers: {
            'Content-Type': 'application/json',
        },
        body: JSON.stringify(postData)
    };
    const response = await fetch(apiUrl, requestOptions)
        .catch(error => {
        console.error('Error during POST request:', error);
    });

    if (response.ok) {
        console.log(response);
    } else {
        throw new Error('Error in server response');
    }
});
